Name:           oraclelinux-release-el7
Version:        1.0
Release:        17%{dist}
Summary:        Oracle Linux yum repository configuration

Group:          System Environment
License:        GPLv2

Source0:        oraclelinux-release-el7-1.0.tgz
Source1:        uek-ol7.repo
Source2:        virt-ol7.repo
Source3:        LICENSE
Source4:        ol_yum_configure.sh
Source5:        uek-ol7.repo.aarch64
Patch1:         security_validation.patch
#Patch2:         ol7u7-beta-repo.patch
Patch3:         add_base_repo_u7.patch
Patch4:         4-add_base_repo_u8.patch
Patch5:         add_base_repo_u9.patch
Patch100:       aarch64_oracle-linux.patch


BuildArch:     x86_64 aarch64
Requires:      grep
Requires:      sed
Requires:      yum-utils
Requires:      curl

%description
This package contains the  Oracle Linux  yum repository configuration.

%package -n yum-config-ociSGW
Summary: Fix yum configuration for SGW use in OCI
Group: System Environment

BuildArch:     noarch
Requires:      grep
Requires:      sed
Requires:      curl

%description -n yum-config-ociSGW
Fix yum configuration to point to local Oracle Linux yum mirror with Service Gateway use.

%prep
%setup  -q  
%patch1 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

%if %{?_host_cpu} == aarch64
%patch100 -p1
%endif

%build


%install
rm -rf $RPM_BUILD_ROOT


install -m 755 -d $RPM_BUILD_ROOT/usr/share/doc/%{name}/
install -m 755 -d $RPM_BUILD_ROOT/usr/share/doc/yum-config-ociSGW-%{version}/
install -m 755 -d $RPM_BUILD_ROOT/usr/bin/
install -m 755 %{SOURCE4} $RPM_BUILD_ROOT/usr/bin/
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d
install -pm 644 %{_builddir}/%{name}-%{version}/oracle-linux-ol7.repo $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d
%if %{?_host_cpu} == x86_64
install -pm 644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d
install -pm 644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d
%endif
%if %{?_host_cpu} == aarch64
install -pm 644 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/yum.repos.d/uek-ol7.repo
%endif
install -m 755 %{SOURCE3}  $RPM_BUILD_ROOT%{_datadir}/doc/%{name}
install -m 755 %{SOURCE3}  $RPM_BUILD_ROOT%{_datadir}/doc/yum-config-ociSGW-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%files -n %{name}
%defattr(-,root,root,-)
%dir %{_datadir}/doc/%{name}
%{_datadir}/doc/%{name}/*
/usr/bin/ol_yum_configure.sh
%config(noreplace) /etc/yum.repos.d/*

%files -n yum-config-ociSGW
%dir %{_datadir}/doc/yum-config-ociSGW-%{version}
%{_datadir}/doc/yum-config-ociSGW-%{version}/*



%pre -n %{name}
if [ -f /etc/yum.repos.d/public-yum-ol7.repo ];then
   enabled_repos=$(yum-config-manager | grep ol7 | grep "^\[" |  egrep -v -e "x86_64|aarch64" | sed -e "s|\[||" | sed -e "s|\]||")
   echo $enabled_repos > /etc/yum.repos.d/.oracle_enable_repolist

   mv /etc/yum.repos.d/public-yum-ol7.repo /etc/yum.repos.d/public-yum-ol7.repo.`date +%Y%m%d`
 echo " "
 RED='\033[0;31m'
 NC='\033[0m' # No Color
 bold=$(tput bold)
 normal=$(tput sgr0)

echo -e "${RED}${bold}IMPORTANT: A legacy Oracle Linux yum server repo file was found.${normal}${NC} Oracle Linux yum server repository configurations have changed which means public-yum-ol7.repo will no longer be updated. New repository configuration files have been installed but are disabled. ${RED}${bold}To complete the transition, run this script as the root user:${normal}${NC}"
echo
echo -e "${RED}${bold}/usr/bin/ol_yum_configure.sh${normal}${NC}"
echo
echo "See https://yum.oracle.com/faq.html for more information."

  echo "   "
  touch /etc/yum.repos.d/.public-yum-ol7.repo.moved
fi

%post -n %{name}

instance_command='curl --max-time 1 -q -f http://169.254.169.254/opc/v2/instance/'


if [ ! -f /etc/yum/vars/ociregion ] || [ "`cat /etc/yum/vars/ociregion 2> /dev/null`" = '-' ]; then
(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" > /dev/null 2>&1)
 if [ $? != 0 ]; then
   echo > /etc/yum/vars/ociregion
   echo oracle.com > /etc/yum/vars/ocidomain
 else
  instance_region=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2> /dev/null | grep regionIdentifier | awk -F\: '{print $2}' | sed -e 's/\"//g' -e 's/ //g' -e 's/,//g')
  instance_domain=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2> /dev/null | grep realmDomainComponent | awk -F: '{print $2}' | sed -e 's/"//g' -e 's/,//g' -e 's/^\s//g')
  instance_realm=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2>/dev/null | grep realmKey | awk -F: '{print $2}' | sed -e 's/"//g' -e 's/,//g' -e 's/^\s//g')
  if [ -z "$instance_region" -o -z "$instance_domain" ]; then
    echo > /etc/yum/vars/ociregion
    echo oracle.com > /etc/yum/vars/ocidomain
  elif [[ $instance_realm =~ (oc5|oc6|oc7) ]]; then
    echo oci.$instance_domain > /etc/yum/vars/ocidomain
    echo ".$instance_region" > /etc/yum/vars/ociregion
  else
    if curl -sfm 10 https://yum-${instance_region}.oracle.com/yum-${instance_region}-ol7.repo > /dev/null || curl -sfm 10 https://yum.${instance_region}.oci.${instance_domain}/yum-${instance_region}-ol7.repo >/dev/null; then
        #if [ $instance_domain != "oraclecloud.com" ]; then
        if [[ $instance_realm =~ (oc5|oc6|oc7) ]]; then
          echo oci.$instance_domain > /etc/yum/vars/ocidomain
          echo ".$instance_region" > /etc/yum/vars/ociregion
        else
          echo oracle.com > /etc/yum/vars/ocidomain
          echo "-$instance_region" > /etc/yum/vars/ociregion
        fi
    else
        echo > /etc/yum/vars/ociregion
        echo oracle.com > /etc/yum/vars/ocidomain
     fi
  fi
 fi
fi
if [ ! -f /etc/yum/vars/ocidomain ]; then
   (http_proxy="";$instance_command -H "Authorization: Bearer Oracle" > /dev/null 2>&1)
    if [ $? != 0 ]; then
      echo oracle.com > /etc/yum/vars/ocidomain
    else
      instance_domain=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2> /dev/null | grep realmDomainComponent | awk -F: '{print $2}' | sed -e 's/"//g' -e 's/,//g' -e 's/^\s//g')
     instance_realm=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2>/dev/null | grep realmKey | awk -F: '{print $2}' | sed -e 's/"//g' -e 's/,//g' -e 's/^\s//g')
       if [ -z $instance_domain ]; then
         echo oracle.com > /etc/yum/vars/ocidomain
       #elif [ $instance_domain != "oraclecloud.com" ]; then
        elif [[ $instance_realm =~ (oc5|oc6|oc7) ]]; then
          echo oci.$instance_domain > /etc/yum/vars/ocidomain
       else
          echo oracle.com > /etc/yum/vars/ocidomain
       fi
    fi
 fi
(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" > /dev/null 2>&1)
 if [ $? = 0 ]; then
  instance_region=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2> /dev/null | grep regionIdentifier | awk -F\: '{print $2}' | sed -e 's/\"//g' -e 's/ //g' -e 's/,//g')
  instance_domain=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2> /dev/null | grep realmDomainComponent | awk -F: '{print $2}' | sed -e 's/"//g' -e 's/,//g' -e 's/^\s//g')
  instance_realm=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s 2>/dev/null | grep realmKey | awk -F: '{print $2}' | sed -e 's/"//g' -e 's/,//g' -e 's/^\s//g')
   #if [ $instance_domain != "oraclecloud.com" ] && curl -sfm 10 https://yum.${instance_region}.oci.${instance_domain}/yum-${instance_region}-ol7.repo > /dev/null; then
   if [[ $instance_realm =~ (oc5|oc6|oc7) ]]; then
     echo ".$instance_region" > /etc/yum/vars/ociregion
   fi
   if [ ! -f /etc/yum.repos.d/.public-yum-ol7.repo.moved ] && [ $(stat -c%s /etc/yum/vars/ociregion) -gt 1 ]; then
    yum-config-manager --enable ol7_addons  > /dev/null
    yum-config-manager --enable ol7_optional_latest > /dev/null
   fi
fi
if [ -f /etc/yum.repos.d/.public-yum-ol7.repo.moved ] && [ -f /etc/yum.repos.d/.oracle_enable_repolist  ]; then
 if [ -f /etc/yum.repos.d/.oracle_enable_repolist  ]; then
    enabled_repos=`cat /etc/yum.repos.d/.oracle_enable_repolist`
    for file in oracle-linux-ol7.repo uek-ol7.repo virt-ol7.repo; do
      repofound=0
      if [ -f /etc/yum.repos.d/$file ]; then
      for i in `grep "^\[" /etc/yum.repos.d/$file | sed -e "s|\[||" | sed -e "s|\]||"`; do
        if echo $enabled_repos | egrep -we "$i|public_$i"  > /dev/null; then
          repofound=1
        fi
      done
     for i in `grep "^\[" /etc/yum.repos.d/$file | sed -e "s|\[||" | sed -e "s|\]||"`; do
       if echo $enabled_repos | egrep -we "$i|public_$i"  > /dev/null; then
         yum-config-manager --enable $i > /dev/null
         sed -i -e "{s/$i //
                  s/$i$//
                  s/public_$i$//
                  s/public_$i //}" /etc/yum.repos.d/.oracle_enable_repolist
       else
        if [ $repofound -eq 1 ]; then
         yum-config-manager --disable $i > /dev/null
        fi
       fi
    done
    fi
  done

 fi
fi
(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" > /dev/null 2>&1)
if [ $? = 0 ]; then
if  [ $(stat -c%s /etc/yum/vars/ociregion) -gt 1 ] && ! grep ol7_ociyum_config /etc/yum.repos.d/oracle-linux-ol7.repo > /dev/null; then
cat << EOF >> /etc/yum.repos.d/oracle-linux-ol7.repo
[ol7_ociyum_config]
name=OCI specific release packages Oracle Linux \$releasever (\$basearch)
baseurl=https://yum\$ociregion.\$ocidomain/repo/OracleLinux/OL7/oci/included/\$basearch/
gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-oracle
gpgcheck=1
enabled=0

EOF
fi
fi


if [ -e /etc/sysconfig/rhn/systemid ];then
    sed -i 's/enabled=1/enabled=0/' /etc/yum.repos.d/oracle-linux-ol7.repo
    if [ -f /etc/yum.repos.d/uek-ol7.repo ]; then
      sed -i 's/enabled=1/enabled=0/' /etc/yum.repos.d/uek-ol7.repo
    fi
    if [ -f  /etc/yum.repos.d/virt-ol7.repo ]; then
      sed -i 's/enabled=1/enabled=0/' /etc/yum.repos.d/virt-ol7.repo
    fi
fi


if [ -f /etc/yum.repos.d/.public-yum-ol7.repo.moved ]; then
  mv /etc/yum.repos.d/oracle-linux-ol7.repo /etc/yum.repos.d/oracle-linux-ol7.repo.disabled
   if [ -f /etc/yum.repos.d/uek-ol7.repo ]; then
    mv /etc/yum.repos.d/uek-ol7.repo /etc/yum.repos.d/uek-ol7.repo.disabled
   fi
   if [ -f /etc/yum.repos.d/virt-ol7.repo ]; then
    mv /etc/yum.repos.d/virt-ol7.repo /etc/yum.repos.d/virt-ol7.repo.disabled
   fi

fi

%posttrans -n %{name}
if [ -f /etc/yum.repos.d/.public-yum-ol7.repo.moved ]; then
   mv /etc/yum.repos.d/public-yum-ol7.repo.`date +%Y%m%d` /etc/yum.repos.d/public-yum-ol7.repo
   rm -f /etc/yum.repos.d/.public-yum-ol7.repo.moved
   if  grep ol7_ociyum_config /etc/yum.repos.d/public-yum-ol7.repo  ; then
      yum-config-manager --disable ol7_ociyum_config
   fi

fi

%post -n yum-config-ociSGW
instance_command='curl --max-time 1 -q -f http://169.254.169.254/opc/v2/instance/'

(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" > /dev/null 2>&1)
 if [ $? = 0 ]; then
  instance_region=$(http_proxy="";$instance_command -H "Authorization: Bearer Oracle" -s | grep "region\" :" | awk -F\" '{print $4}' | cut -d '-' -f 2)
  if [ ! -z "$instance_region" ]; then
    if curl -sfm 10 https://yum-${instance_region}.oracle.com/yum-${instance_region}-ol7.repo > /dev/null; then
        if [ -f /etc/yum.repos.d/public-yum-ol7.repo ]; then
          echo "-$instance_region" > /etc/yum/vars/regiont
          cp -p /etc/yum.repos.d/public-yum-ol7.repo /etc/yum.repos.d/public-yum-ol7.`date +%Y%m%d`
          sed -i "s|yum.*.oracle.com|yum\$regiont.oracle.com|" /etc/yum.repos.d/public-yum-ol7.repo
        fi
    fi
  fi
 fi



%changelog
* Tue Jun  8 2021 Keshav Sharma <keshav.sharma@oracle.com> 1.0-17
- Added Oracle Linux 7.8 security validation repository.
- Fixed architecture for ol7_ociyum_config repository [OraBug: 32754445]

* Fri Mar 12 2021 Keshav Sharma <keshav.sharma@oracle.com> 1.0-16
- Add leapp repository [OraBug: 32625250]

* Tue Mar 02 2021 Keshav Sharma <keshav.sharma@oracle.com> 1.0-15
- Fix enabling of oci specific repository in container environment [ OraBug: 32577769 ]

* Mon Aug 10 2020 Keshav Sharma <keshav.sharma@oracle.com> 1.0-14
- Add ocidomain as yum variable [ OraBug: 31840501]
- Added 7.9 repositories [OraBug: 31957552]
- Enable UEKR6 and disable UEKR5 repositories [OraBug: 31482423]

* Wed Jul 06 2020 Keshav Sharma <keshav.sharma@oracle.com> 1.0-12.1
- Fix postinstall script  [OraBug: 31574264 ]

* Wed Apr 01 2020 Keshav Sharma <keshav.sharma@oracle.com> 1.0-12
- Use https for OCI yum mirror repositories  [OraBug: 31220677]
- Use IMDS v2 for OCI.

* Wed Apr 01 2020 Keshav Sharma <keshav.sharma@oracle.com> 1.0-11
- Added OL7.8  repositories  [OraBug: 30641840]

* Mon Mar 23 2020 Keshav Sharma <keshav.sharma@oracle.com> 1.0-10
- Added UEK6 repository entry [OraBug: 31074697]

* Wed Aug 07 2019 Keshav Sharma <keshav.sharma@oracle.com> 1.0-8
- Added OL7.7  repositories  [OraBug: 30095349]
- Remove jq dependency [OraBug: 30098049]

* Fri Aug 02 2019 Keshav Sharma <keshav.sharma@oracle.com> 1.0-7
- Added OL7.7 Beta repositories  [OraBug: 30117282]

* Thu Mar 14 2019 Keshav Sharma <keshav.sharma@oracle.com> 1.0-6
- Added yum-config-ociSGW
- increased timeout for curl command to 10 seconds

* Wed Feb 13 2019 Keshav Sharma <keshav.sharma@oracle.com> 1.0-5
- Fix ol_yum_configure.sh [ OraBug 29241080]

* Wed Jan 23 2019 Keshav Sharma <keshav.sharma@oracle.com> 1.0-4
- Enhance logic to detect oci instance [ OraBug 29241080]
- Do not overwrite /etc/yun/vars/ociregion file.
- Exit ol_yum_configure.sh if another yum command running

* Tue Jan 15 2019 Keshav Sharma <keshav.sharma@oracle.com> 1.0-3
-  Exit ol_yum_configure.sh on install failure [ OraBug 29216253 ]

* Mon Jan 14 2019 Keshav Sharma <keshav.sharma@oracle.com> 1.0-2
- Added ol7_security_validation repository.

* Tue Aug 28 2018 Tony Lam <tony.l.lam@oracle.com> 1.0-1
- Initial package

